import React, { useState } from "react";
import { View } from "@tarojs/components";

import style from "./index.module.less";

interface Props {
  current: string;
  full?: boolean;
  tabStyle?: string;
  list: {
    key: string;
    label: string | React.ReactChild;
    children?: React.ReactChild | React.ReactChild[];
  }[];
}

export default function Index({
  tabStyle = "card",
  current,
  full,
  list,
}: Props) {
  const [tabIndex, setTabIndex] = useState(current ?? list[0].key);

  const renderTabContent = () => {
    return (
      <View>
        {list.map((item) => {
          return (
            <View
              className={
                item.key === tabIndex ? style.visible : style.invisible
              }
            >
              {item.children}
            </View>
          );
        })}
      </View>
    );
  };

  // if (tabStyle === "outline") {
  //   return (
  //     <View>
  //       <View className="tab-buttons">
  //         {list.map((item) => {
  //           return (
  //             <View
  //               key={item.key}
  //               className={`tab-button  ${
  //                 tabIndex === item.key ? "tabButton-actived" : ""
  //               }
  //                 ${full ? "flex flex-1 items-center justify-center" : ""}
  //               `}
  //               onClick={() => setTabIndex(item.key)}
  //             >
  //               {item.label}
  //             </View>
  //           );
  //         })}
  //       </View>
  //       {renderTabContent()}
  //     </View>
  //   );
  // }

  // if (tabStyle === "button") {
  //   return (
  //     <View>
  //     <View className={`flex items-center gap-10 py-8 px-10 ${style.buttonTabs}`}>
  //       {list.map((item) => {
  //         return (
  //           <View
  //             key={item.key}
  //             className={`${style.buttonTab}  ${
  //               tabIndex === item.key ? style.buttonTabActived : ""
  //             }
  //                 flex-1 shrink-0
  //               `}
  //             onClick={() => setTabIndex(item.key)}
  //           >
  //             {item.label}
  //           </View>
  //         );
  //       })}
  //     </View>
  //     {renderTabContent()}
  //     </View>
  //   );
  // }

  return (
    <View>
      <View className="flex items-center gap-8">
        {list.map((item) => {
          return (
            <View
              key={item.key}
              className={tabIndex === item.key ? style.rounedButtonActived : style.rounedButton}
              onClick={() => setTabIndex(item.key)}
            >
              {item.label}
            </View>
          );
        })}
      </View>
      {renderTabContent()}
    </View>
  );
}
