import { View } from '@tarojs/components'
import { TFileItem } from '@/types/file-types'
import style from './index.module.less'
import FileUploader from './file-uploader'
import { useDocumentStore  } from '@/store/documentStore'
import { useCharacterStore  } from '@/store/characterStore'
interface Props {
  fileItem: TFileItem
  onStart: (r: Taro.UploadTask.UploadTaskPromise, fileItem: TFileItem)=> void
  onUploaded: (fileItem: TFileItem)=> void
}
export default  ({fileItem, onStart, onUploaded}: Props) => {
  const { createDocument, setUploadListItem} = useDocumentStore()
  const character = useCharacterStore((state)=> state.character)
  
  const handleFileUploaded = async (res:any, fileItem: TFileItem) => {
    setTimeout(async ()=> {
    // setState(2)
      setUploadListItem({...fileItem, status: 2})
      if(!res.data){
        return
      }
      if(!character?.profileId){
        return;
      }
      const d = await createDocument({
        filename: fileItem.file.name,
        characterProfileId: character.profileId,
        link: res.data,
        size: fileItem.file.size,
      })
      if(d){
        onUploaded(fileItem)
      }
      console.log(d)
    }, 600)
    
  }

  const handleFileUploadStart = (task: Taro.UploadTask.UploadTaskPromise) => {
    const f = {...fileItem, status: 3}
    setUploadListItem(f)
    onStart(task, f)
    // setState(1)
    // // 将开始上传的任务句柄存入 list 内
    // // item.taskHandler
    // const i = list.findIndex(item=> item.file.path === fileItem.file.path);
    // if(i > -1){
    //   const _item = {...list[i], taskHandler: fileItem.taskHandler}
    //   const _list = [...list.slice(0, i), _item, ...list.slice(i)]
    //   setList(_list)
    // }
    
  }
  const renderFileStatus = () => {
    if(fileItem.status === 2){
      return <></>
    }
    if(fileItem.status === 1){
      return (
        <View className={style.wait}>等待上传...</View>
      )
    }
    return (
      <View className='py-5'>
        <FileUploader file={fileItem} onUploaded={handleFileUploaded} onStart={handleFileUploadStart}></FileUploader>
      </View>
    )
  }
  return (
    <>
      {renderFileStatus()}
    </>
  )
}