import { PageContainer } from "@tarojs/components";

interface Props {
  setShow: (show: boolean) => void;
  show: boolean;
}

export default ({
  setShow,
  show,
  children,
}: React.PropsWithChildren<Props>) => {
  const handlePopupLeave = () => {
    setShow(false);
  };

  return (
    <PageContainer
      show={show}
      round
      overlay
      overlayStyle='background-color: rgba(0, 0, 0, 0.65)'
      duration={300}
      position='bottom'
      customStyle='height: 70%;'
      onAfterLeave={handlePopupLeave}
    >
      {children}
    </PageContainer>
  );
};
